package eu.beesoft.gantt.demo;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import eu.beesoft.gaia.util.AbstractBean;

public class Resource extends AbstractBean implements Comparable<Resource> {

	private String name;

	private List<Task> tasks;



	public String getName () {
		return name;
	}



	public void setName (String name) {
		String old = this.name;
		this.name = name;
		firePropertyChange ("name", old, name);
	}



	public List<Task> getTasks () {
		if (tasks == null) {
			return Collections.emptyList ();
		}
		return tasks;
	}



	public void addTask (Task task) {
		if (tasks == null) {
			tasks = new ArrayList<Task> ();
		}
		else if (tasks.contains (task)) {
			return;
		}
		tasks.add (task);
		task.setAssignee (this);
	}



	public void removeTask (Task task) {
		if (tasks != null) {
			if (tasks.contains (task)) {
				tasks.remove (task);
				if (task.getAssignee () == this) {
					task.setAssignee (null);
				}
			}
		}
	}



	public int compareTo (Resource resource) {
		return name.compareTo (resource.getName ());
	}



	@Override
	public String toString () {
		return getName ();
	}
}
